<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <NuxtLayout name="default">
        <div class="catalog-page">

            <!-- sidebar navigation teleported to template -->
            <SidebarNav :nav="navItems" :title="'Glossary'" />

            <Datatable :data="data" @open-edit-modal="handleOpenEditModal" @refreshData="fetchGlossaryData">
                <button class="button-secondary orange" @click="handleCreateNewGlossary">New Glossary</button>
                <div class="filters-top-totals"><b>{{ glossaryLength > 0 ? glossaryLength : '' }} Glossaries</b> available</div>
            </Datatable>

            <div class="container">
                <div class="offset-xl-1 col-xl-10 mt-160">
                    <BannersBannerCta :banners="BannerCta" />
                </div>
            </div>

            <ClientOnly>
                <Teleport to="#modals-container">
                    <ModalsCreateGlossary v-if="showCreateGlossaryModal" :row="selectedRow" @toggle="close" :isEditMode="isEditMode" @refresh-data="fetchGlossaryData" />
                </Teleport>
            </ClientOnly>

        </div>
    </NuxtLayout>
</template>
<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import type NavItemI from '~/interfaces/navItem';
import type sliderItemI from '~/interfaces/sliderItem';
import slide1 from '@/assets/images/slide1.png';
import { formatDate, removeHtmlTags } from '~/utils/utils';
import { storeToRefs } from 'pinia';
import { useDataStore } from '@/stores/dataStore';

useHead({
    title: 'Glossary - DATAMITE'
});

const route = useRoute();
const dataStore = useDataStore();
const { refreshKey } = storeToRefs(dataStore); 

const showCreateGlossaryModal = ref(false);
const selectedRow = ref(null);
const isEditMode = ref(false);

const handleOpenEditModal = (row: any) => {

  selectedRow.value = row?.id; // Pass the selected row data to the modal
  isEditMode.value = true;
  showCreateGlossaryModal.value = true; // Open the Edit Glossary modal
};

const handleCreateNewGlossary = () => {
  selectedRow.value = null; // No selected row for creating a new glossary
  isEditMode.value = false; // Set the flag to false for create mode
  showCreateGlossaryModal.value = true; // Open the modal
};

const close = () => {
    showCreateGlossaryModal.value = false;
    fetchGlossaryData();
};
/** GLOSSARY - fetch data from api **/

interface Glossary {
    id: number;
    name: string;
    type: string;
    group: string;
    domains: any;
    summary: string;
    updatedAt: string;
    createdAt: string;
    terms: any
}

const glossaryLength = ref(0);

const fetchGlossaryData = () => {

    console.log('fetchGlossaryData');

    useFetchAuth('/glossaries')
    .then((response: any) => {

        const glossary: Glossary[] = response;

        glossaryLength.value = glossary.length;

        // Map the response data to match the structure of `rows`
        // Update the rows in `data`
        data.value.rows = glossary.map((term: Glossary, index: number) => ({
            id: term.id,
            name: term.name,
            type: 'Glossary',
            // group: 'Term Group',
            domain: term?.domains?.join(', '),
            description: removeHtmlTags(term.summary),
            edited_at: formatDate(term.updatedAt),
            created_at: formatDate(term.createdAt),
            terms: term?.terms,
            actions: ''
        }));

        console.log('data.value.rows', data.value.rows);

        // scroll top
        window.scrollTo(0, 0);

    })
    .catch(error => {
        console.error('API Error:', error);
    });

}

onBeforeMount(() => {
    fetchGlossaryData();
});

watch(refreshKey, async(newKey) => {
	console.log('refreshKey', newKey);
	fetchGlossaryData();
});

const data = ref<DataTableI>({
    options: {
        tableName: 'glossary-table',
        detailsPath: '/glossary/',
        allowCheckRow: true,
        favourites: true,
        previewComponent: 'GlossaryDetails',
    },
    columns: [
        {
            id: 1,
            name: 'name',
            label: 'Name',
            combineColumn: 'type',
            renderComponent: 'TableColumnsName',
            width: '200px'
        },
        // {
        //     id: 2,
        //     name: 'group',
        //     label: 'Group',
        //     width: '180px'
        // },
        {
            id: 3,
            name: 'domain',
            label: 'Domain',
            width: '250px'
        },
        {
            id: 4,
            name: 'description',
            label: 'Description',
            width: '400px'
        },
        {
            id: 5,
            name: 'edited_at',
            label: 'Edited at',
            width: '160px'
        },
        {
            id: 6,
            name: 'actions',
            label: 'Actions',
            width: '80px',
            hideLabel: true
        }
    ],
    rows: []
});

const dummyClick = () => {
    console.log('dummyClick');
}

const goToGlossary = () => {
    navigateTo('/glossary');
}

const goToAllTerms = () => {
    console.log('goToAllTerms');
    navigateTo('/glossary/terms');
}

const navItems = ref<NavItemI[]>([
    {
        label: 'Glossary',
        icon: 'vocabularies_nav',
        action: goToGlossary,
        active: true
    }, {
        label: 'All terms',
        icon: 'clock',
        action: goToAllTerms,
    },
    {
        label: 'Recently viewed',
        icon: 'clock',
        action: dummyClick
    },
    {
        label: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Your Catalog',
        icon: 'loading',
        action: dummyClick
    }
]);

const BannerCta = ref<sliderItemI[]>([
    {
        id: 1,
        title: 'Have a question or doubts?',
        text: 'Check our FAQs and Documentation',
        button_text: 'Faqs and Documentation',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide1,
        template: 1,
    }
])

</script>